# Clickhouse Resource Provider

The Clickhouse Resource Provider lets you manage [clickhouse](https://www.pulumi.com/registry/packages/clickhouse/) resources.

## Sponsored By

* [Fiveonefour](https://www.fiveonefour.com/)

## Installing

This package is available for several languages/platforms:

### Node.js (JavaScript/TypeScript)

To use from JavaScript or TypeScript in Node.js, install using either `npm`:

```bash
npm install @pulumiverse/clickhouse
```

or `yarn`:

```bash
yarn add @pulumiverse/clickhouse
```

### Python

To use from Python, install using `pip`:

```bash
pip install pulumiverse_clickhouse
```

### Go

To use from Go, use `go get` to grab the latest version of the library:

```bash
go get github.com/pulumiverse/pulumi-clickhouse/sdk/go/...
```

### .NET

To use from .NET, install using `dotnet add package`:

```bash
dotnet add package Pulumiverse.Clickhouse
```

## Reference

For detailed reference documentation, please visit [the Pulumi registry](https://www.pulumi.com/registry/packages/clickhouse/api-docs/).

## Support

If you run into any issue, please file and [issue](https://github.com/pulumiverse/pulumi-clickhouse/issues/new) in the github repository, or 
come [ask us for help in the moose community](https://join.slack.com/t/moose-community/shared_invite/zt-2fjh5n3wz-cnOmM9Xe9DYAgQrNu8xKxg)

## Used By

Please make a PR adding your company or product if you are using this
provider in production.

* [Boreal](https://www.boreal.cloud) hosting platform for Moose projects (open source developer framework for data engineering workloads)